Index: trunk/src/VBox/Installer/darwin/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/darwin/Makefile.kmk	(revision 37423)
+++ trunk/src/VBox/Installer/darwin/Makefile.kmk	(revision 37549)
@@ -661,4 +661,8 @@
 	Resources/virtualbox-ovf.icns \
 	Resources/virtualbox-ova.icns \
+	Resources/virtualbox-vdi.icns \
+	Resources/virtualbox-vmdk.icns \
+	Resources/virtualbox-vhd.icns \
+	Resources/virtualbox-hdd.icns \
 	MacOS/components/VBoxXPCOMBase.xpt \
 	MacOS/components/VirtualBox_XPCOM.xpt
Index: trunk/src/VBox/Installer/linux/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 37423)
+++ trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 37549)
@@ -283,5 +283,5 @@
 VBOX_MIME_ICONS = \
 	$(addprefix $(PATH_ROOT)/src/VBox/Resources/other/,\
-	    $(foreach f,ova ovf vbox vbox-extpack, \
+	    $(foreach f,ova ovf vbox vbox-extpack vdi vmdk vhd hdd, \
 	        $(foreach s,16 20 24 32 48 64 72 96 128 256,\
 		    virtualbox-$(f)-$(s)px.png=>$(s)x$(s)/virtualbox-$(f).png)))
Index: trunk/src/VBox/Installer/solaris/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 37423)
+++ trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 37549)
@@ -185,10 +185,10 @@
 VBOX_MIME_ICONS = \
 	$(addprefix $(PATH_ROOT)/src/VBox/Resources/other/,\
-	    $(foreach f,ova ovf vbox vbox-extpack, \
+	    $(foreach f,ova ovf vbox vbox-extpack vdi vmdk vhd hdd, \
 	        $(foreach s,16 20 24 32 48 64 72 96 128 256,\
 	            virtualbox-$(f)-$(s)px.png=>$(s)x$(s)/mimetypes/virtualbox-$(f).png)))
 
 SOLARIS_COMMON_ICONS = \
-	$(foreach f,ova ovf vbox vbox-extpack, \
+	$(foreach f,ova ovf vbox vbox-extpack vdi vmdk vhd hdd, \
 	    $(foreach s,16 20 24 32 48 64 72 96 128 256,\
 	        $(s)x$(s)/mimetypes/virtualbox-$(f).png))
Index: trunk/src/VBox/Installer/solaris/virtualbox.applications.in
===================================================================
--- trunk/src/VBox/Installer/solaris/virtualbox.applications.in	(revision 37423)
+++ trunk/src/VBox/Installer/solaris/virtualbox.applications.in	(revision 37549)
@@ -5,4 +5,4 @@
     can_open_multiple_files=true
     name=@VBOX_PRODUCT@
-    mime_types=application/x-virtualbox-vbox;application/x-virtualbox-vbox-extpack;application/x-virtualbox-ovf;application/x-virtualbox-ova
+    mime_types=application/x-virtualbox-vbox;application/x-virtualbox-vbox-extpack;application/x-virtualbox-ovf;application/x-virtualbox-ova;application/x-virtualbox-vdi;application/x-virtualbox-vmdk;application/x-virtualbox-vhd;application/x-virtualbox-hdd
 
Index: trunk/src/VBox/Installer/solaris/virtualbox.keys
===================================================================
--- trunk/src/VBox/Installer/solaris/virtualbox.keys	(revision 37423)
+++ trunk/src/VBox/Installer/solaris/virtualbox.keys	(revision 37549)
@@ -39,2 +39,41 @@
     use_category_default=no
 
+application/x-virtualbox-vdi
+    icon_filename=virtualbox-vdi
+    description=Virtual Disk Image
+    default_action_type=none
+    short_list_application_ids_for_novice_user_level=virtualbox
+    short_list_application_ids_for_intermediate_user_level=virtualbox
+    short_list_application_ids_for_advanced_user_level=virtualbox
+    category=System
+    use_category_default=no
+
+application/x-virtualbox-vmdk
+    icon_filename=virtualbox-vmdk
+    description=Virtual Machine Disk Format
+    default_action_type=none
+    short_list_application_ids_for_novice_user_level=virtualbox
+    short_list_application_ids_for_intermediate_user_level=virtualbox
+    short_list_application_ids_for_advanced_user_level=virtualbox
+    category=System
+    use_category_default=no
+
+application/x-virtualbox-vhd
+    icon_filename=virtualbox-vhd
+    description=Virtual Hard Disk
+    default_action_type=none
+    short_list_application_ids_for_novice_user_level=virtualbox
+    short_list_application_ids_for_intermediate_user_level=virtualbox
+    short_list_application_ids_for_advanced_user_level=virtualbox
+    category=System
+    use_category_default=no
+
+application/x-virtualbox-hdd
+    icon_filename=virtualbox-hdd
+    description=Virtual Hard Disk
+    default_action_type=none
+    short_list_application_ids_for_novice_user_level=virtualbox
+    short_list_application_ids_for_intermediate_user_level=virtualbox
+    short_list_application_ids_for_advanced_user_level=virtualbox
+    category=System
+    use_category_default=no
Index: trunk/src/VBox/Installer/solaris/virtualbox.mime
===================================================================
--- trunk/src/VBox/Installer/solaris/virtualbox.mime	(revision 37423)
+++ trunk/src/VBox/Installer/solaris/virtualbox.mime	(revision 37549)
@@ -10,2 +10,14 @@
 application/x-virtualbox-ova:
     ext: ova
+
+application/x-virtualbox-vdi:
+    ext: vdi
+
+application/x-virtualbox-vmdk:
+    ext: vmdk
+
+application/x-virtualbox-vhd:
+    ext: vhd
+
+application/x-virtualbox-hdd:
+    ext: hdd
Index: trunk/src/VBox/Installer/win/Resources/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/win/Resources/Makefile.kmk	(revision 37423)
+++ trunk/src/VBox/Installer/win/Resources/Makefile.kmk	(revision 37549)
@@ -43,4 +43,8 @@
   VBOX_WINDOWS_ICON_EXT_OVA     := $(VBOX_RESOURCES_PATH_WIN)/OSE/virtualbox-ova.ico
   VBOX_WINDOWS_ICON_EXT_OVF     := $(VBOX_RESOURCES_PATH_WIN)/OSE/virtualbox-ovf.ico
+  VBOX_WINDOWS_ICON_EXT_VDI     := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-vdi.ico
+  VBOX_WINDOWS_ICON_EXT_VMDK    := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-vmdk.ico
+  VBOX_WINDOWS_ICON_EXT_VHD     := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-vhd.ico
+  VBOX_WINDOWS_ICON_EXT_HDD     := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-hdd.ico
 else
   VBOX_WINDOWS_ICON_EXT_VBOX    := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-vbox.ico
@@ -48,4 +52,8 @@
   VBOX_WINDOWS_ICON_EXT_OVA     := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-ova.ico
   VBOX_WINDOWS_ICON_EXT_OVF     := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-ovf.ico
+  VBOX_WINDOWS_ICON_EXT_VDI     := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-vdi.ico
+  VBOX_WINDOWS_ICON_EXT_VMDK    := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-vmdk.ico
+  VBOX_WINDOWS_ICON_EXT_VHD     := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-vhd.ico
+  VBOX_WINDOWS_ICON_EXT_HDD     := $(VBOX_RESOURCES_PATH_WIN)/virtualbox-hdd.ico
 endif
 
@@ -55,5 +63,8 @@
 	$(VBOX_WINDOWS_ICON_EXT_EXTPACK) \
 	$(VBOX_WINDOWS_ICON_EXT_OVA) \
-	$(VBOX_WINDOWS_ICON_EXT_OVF)
+	$(VBOX_WINDOWS_ICON_EXT_OVF) \
+	$(VBOX_WINDOWS_ICON_EXT_VMDK) \
+	$(VBOX_WINDOWS_ICON_EXT_VHD) \
+	$(VBOX_WINDOWS_ICON_EXT_HDD)
 
 $$(VBoxRes_0_OUTDIR)/VBoxRes-icons.rc: \
@@ -63,6 +74,9 @@
 	$(APPEND) $@ 'IDI_FILETYPE_VBOX         ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ICON_EXT_VBOX))"'
 	$(APPEND) $@ 'IDI_FILETYPE_VBOX_EXTPACK ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ICON_EXT_EXTPACK))"'
-	$(APPEND) $@ 'IDI_FILETYPE_VBOX_OVA 		ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ICON_EXT_OVA))"'
-	$(APPEND) $@ 'IDI_FILETYPE_VBOX_OVF 		ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ICON_EXT_OVF))"'
+	$(APPEND) $@ 'IDI_FILETYPE_VBOX_OVA 	ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ICON_EXT_OVA))"'
+	$(APPEND) $@ 'IDI_FILETYPE_VBOX_OVF 	ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ICON_EXT_OVF))"'
+	$(APPEND) $@ 'IDI_FILETYPE_VBOX_VMDK 	ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ICON_EXT_VMDK))"'
+	$(APPEND) $@ 'IDI_FILETYPE_VBOX_VHD 	ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ICON_EXT_VHD))"'
+	$(APPEND) $@ 'IDI_FILETYPE_VBOX_HDD 	ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ICON_EXT_HDD))"'
 
 include	$(KBUILD_PATH)/subfooter.kmk
Index: trunk/src/VBox/Installer/win/Resources/resource.h
===================================================================
--- trunk/src/VBox/Installer/win/Resources/resource.h	(revision 37423)
+++ trunk/src/VBox/Installer/win/Resources/resource.h	(revision 37549)
@@ -23,2 +23,6 @@
 #define IDI_FILETYPE_VBOX_OVF       301
 #define IDI_FILETYPE_VBOX_OVA       302
+#define IDI_FILETYPE_VBOX_VDI       303
+#define IDI_FILETYPE_VBOX_VMDK      304
+#define IDI_FILETYPE_VBOX_VHD       305
+#define IDI_FILETYPE_VBOX_HDD       306
Index: trunk/src/VBox/Installer/win/VirtualBox.wxs
===================================================================
--- trunk/src/VBox/Installer/win/VirtualBox.wxs	(revision 37423)
+++ trunk/src/VBox/Installer/win/VirtualBox.wxs	(revision 37549)
@@ -386,4 +386,16 @@
                             </Extension>
                         </ProgId>
+                        <ProgId Id="progId_VirtualBox.Shell.vdi" Description="Virtual Disk Image" Icon="file_VBoxRes.dll" IconIndex="-303">
+                            <Extension Id="vdi" ContentType="application/x-virtualbox-vdi" />
+                        </ProgId>
+                        <ProgId Id="progId_VirtualBox.Shell.vmdk" Description="Virtual Machine Disk Format" Icon="file_VBoxRes.dll" IconIndex="-304">
+                            <Extension Id="vmdk" ContentType="application/x-virtualbox-vmdk" />
+                        </ProgId>
+                        <ProgId Id="progId_VirtualBox.Shell.vhd" Description="Virtual Hard Disk" Icon="file_VBoxRes.dll" IconIndex="-305">
+                            <Extension Id="vhd" ContentType="application/x-virtualbox-vhd" />
+                        </ProgId>
+                        <ProgId Id="progId_VirtualBox.Shell.hdd" Description="Virtual Hard Disk" Icon="file_VBoxRes.dll" IconIndex="-306">
+                            <Extension Id="hdd" ContentType="application/x-virtualbox-hdd" />
+                        </ProgId>
 
                         <!-- Files -->