Index: trunk/src/VBox/Devices/Network/slirp/bootp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/bootp.c	(revision 37745)
+++ trunk/src/VBox/Devices/Network/slirp/bootp.c	(revision 37746)
@@ -256,7 +256,7 @@
     /* Address/port of the DHCP server. */
     rbp->bp_yiaddr = bc->addr; /* Client IP address */
-    Log(("NAT: DHCP: bp_yiaddr:%R[naipv4]\n", &rbp->bp_yiaddr));
+    Log(("NAT: DHCP: bp_yiaddr:%RTnaipv4\n", rbp->bp_yiaddr));
     rbp->bp_siaddr = pData->tftp_server; /* Next Server IP address, i.e. TFTP */
-    Log(("NAT: DHCP: bp_siaddr:%R[naipv4]\n", &rbp->bp_siaddr));
+    Log(("NAT: DHCP: bp_siaddr:%RTnaipv4\n", rbp->bp_siaddr));
     if (fDhcpRequest)
     {
@@ -268,5 +268,5 @@
     saddr.s_addr = pData->special_addr.s_addr;
 #endif
-    Log(("NAT: DHCP: s_addr:%R[naipv4]\n", &saddr));
+    Log(("NAT: DHCP: s_addr:%RTnaipv4\n", saddr));
 
 #define FILL_BOOTP_EXT(q, tag, len, pvalue)                     \
@@ -455,5 +455,5 @@
                if ((bp->bp_ciaddr.s_addr & RT_H2N_U32(pData->netmask)) != pData->special_addr.s_addr)
                {
-                   LogRel(("NAT: Client %R[naipv4] requested IP -- sending NAK\n", &bp->bp_ciaddr));
+                   LogRel(("NAT: Client %RTnaipv4 requested IP -- sending NAK\n", bp->bp_ciaddr));
                    offReply = dhcp_send_nack(pData, bp, bc, m);
                    return offReply;
@@ -479,5 +479,5 @@
             if ((ui32 & RT_H2N_U32(pData->netmask)) != pData->special_addr.s_addr)
             {
-                LogRel(("NAT: address %R[naipv4] has been requested -- sending NAK\n", &ui32));
+                LogRel(("NAT: address %RTnaipv4 has been requested -- sending NAK\n", ui32));
                 offReply = dhcp_send_nack(pData, bp, bc, m);
                 return offReply;
@@ -503,5 +503,5 @@
     }
 
-    LogRel(("NAT: DHCP offered IP address %R[naipv4]\n", &bc->addr));
+    LogRel(("NAT: DHCP offered IP address %RTnaipv4\n", bc->addr));
     offReply = dhcp_send_ack(pData, bp, bc, m, /* fDhcpRequest=*/ 1);
     return offReply;
@@ -530,5 +530,5 @@
 
         bc->xid = bp->bp_xid;
-        LogRel(("NAT: DHCP offered IP address %R[naipv4]\n", &bc->addr));
+        LogRel(("NAT: DHCP offered IP address %RTnaipv4\n", bc->addr));
         offReply = dhcp_send_offer(pData, bp, bc, m);
         return offReply;
@@ -543,5 +543,5 @@
         }
 
-        LogRel(("NAT: DHCP offered IP address %R[naipv4]\n", &bc->addr));
+        LogRel(("NAT: DHCP offered IP address %RTnaipv4\n", bc->addr));
         offReply = dhcp_send_ack(pData, bp, bc, m, /* fDhcpRequest=*/ 0);
         return offReply;
@@ -554,5 +554,5 @@
 {
     int rc = release_addr(pData, &bp->bp_ciaddr);
-    LogRel(("NAT: %s %R[naipv4]\n",
+    LogRel(("NAT: %s %RTnaipv4\n",
             RT_SUCCESS(rc) ? "DHCP released IP address" : "Ignored DHCP release for IP address",
             &bp->bp_ciaddr));
@@ -710,5 +710,5 @@
                 bc->addr.s_addr = req_ip.s_addr;
                 slirp_arp_who_has(pData, bc->addr.s_addr);
-                LogRel(("NAT: %R[naipv4] has been already registered\n", &req_ip));
+                LogRel(("NAT: %RTnaipv4 has been already registered\n", req_ip));
             }
             /* no response required */
Index: trunk/src/VBox/Devices/Network/slirp/dnsproxy/dnsproxy.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/dnsproxy/dnsproxy.c	(revision 37745)
+++ trunk/src/VBox/Devices/Network/slirp/dnsproxy/dnsproxy.c	(revision 37746)
@@ -358,5 +358,5 @@
         so->so_expire = curtime + recursive_timeout * 1000; /* let's slirp to care about expiration */
         /* send it to our authoritative server */
-        Log2(("NAT: request will be sent to %R[naipv4] on %R[natsock]\n", &addr.sin_addr, so));
+        Log2(("NAT: request will be sent to %RTnaipv4 on %R[natsock]\n", addr.sin_addr, so));
         if ((byte = sendto(so->s, buf, (unsigned int)byte, 0,
                     (struct sockaddr *)&addr,
@@ -367,5 +367,5 @@
         }
         so->so_state = SS_ISFCONNECTED; /* now it's selected */
-        Log2(("NAT: request was sent to %R[naipv4] on %R[natsock]\n", &addr.sin_addr, so));
+        Log2(("NAT: request was sent to %RTnaipv4 on %R[natsock]\n", addr.sin_addr, so));
 #endif
         ++authoritative_queries;
Index: trunk/src/VBox/Devices/Network/slirp/ip_icmp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/ip_icmp.c	(revision 37745)
+++ trunk/src/VBox/Devices/Network/slirp/ip_icmp.c	(revision 37746)
@@ -263,5 +263,5 @@
             {
                 /* Should be reaplaced by hash here */
-                Log(("trying:%R[natsock] against %R[naipv4]:%d lport=%d hlport=%d\n", so, &faddr, fport, lport, so->so_hlport));
+                Log(("trying:%R[natsock] against %RTnaipv4:%d lport=%d hlport=%d\n", so, &faddr, fport, lport, so->so_hlport));
                 if (   so->so_faddr.s_addr == faddr.s_addr
                     && so->so_fport == fport
Index: trunk/src/VBox/Devices/Network/slirp/ip_input.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/ip_input.c	(revision 37745)
+++ trunk/src/VBox/Devices/Network/slirp/ip_input.c	(revision 37746)
@@ -113,5 +113,5 @@
     LogFlow(("ip_input: m = %lx\n", (long)m));
     ip = mtod(m, struct ip *);
-    Log2(("ip_dst=%R[naipv4](len:%d) m_len = %d\n", &ip->ip_dst, RT_N2H_U16(ip->ip_len), m->m_len));
+    Log2(("ip_dst=%RTnaipv4(len:%d) m_len = %d\n", ip->ip_dst, RT_N2H_U16(ip->ip_len), m->m_len));
 
     ipstat.ips_total++;
@@ -238,6 +238,6 @@
 
 bad_free_m:
-    Log2(("NAT: IP datagram to %R[naipv4] with size(%d) claimed as bad\n",
-        &ip->ip_dst, ip->ip_len));
+    Log2(("NAT: IP datagram to %RTnaipv4 with size(%d) claimed as bad\n",
+        ip->ip_dst, ip->ip_len));
     m_freem(pData, m);
 no_free_m:
Index: trunk/src/VBox/Devices/Network/slirp/libalias/alias_dns.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/libalias/alias_dns.c	(revision 37745)
+++ trunk/src/VBox/Devices/Network/slirp/libalias/alias_dns.c	(revision 37746)
@@ -79,7 +79,7 @@
         return -1;
 
-    Log(("NAT:%s: ah(dport: %hd, sport: %hd) oaddr:%R[naipv4] aaddr:%R[naipv4]\n",
+    Log(("NAT:%s: ah(dport: %hd, sport: %hd) oaddr:%RTnaipv4 aaddr:%RTnaipv4\n",
         __FUNCTION__, ntohs(*ah->dport), ntohs(*ah->sport),
-        &ah->oaddr, &ah->aaddr));
+        ah->oaddr, ah->aaddr));
 
     if (   (ntohs(*ah->dport) == DNS_CONTROL_PORT_NUMBER
Index: trunk/src/VBox/Devices/Network/slirp/slirp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 37745)
+++ trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 37746)
@@ -335,5 +335,5 @@
             }
 
-            Log(("NAT: adding %R[naipv4] to DNS server list\n", &InAddr));
+            Log(("NAT: adding %RTnaipv4 to DNS server list\n", InAddr));
             if ((InAddr.s_addr & RT_H2N_U32_C(IN_CLASSA_NET)) == RT_N2H_U32_C(INADDR_LOOPBACK & IN_CLASSA_NET))
                 pDns->de_addr.s_addr = RT_H2N_U32(RT_N2H_U32(pData->special_addr.s_addr) | CTL_ALIAS);
@@ -1470,5 +1470,5 @@
                 if (!fGratuitousArpReported)
                 {
-                    LogRel(("NAT: Gratuitous ARP [IP:%R[naipv4], ether:%RTmac]\n",
+                    LogRel(("NAT: Gratuitous ARP [IP:%RTnaipv4, ether:%RTmac]\n",
                             ah->ar_sip, ah->ar_sha));
                     fGratuitousArpReported = true;
@@ -1686,6 +1686,6 @@
 #endif
 
-        LogRel(("NAT: set redirect %s host port %d => guest port %d @ %R[naipv4]\n",
-               rule->proto == IPPROTO_UDP ? "UDP" : "TCP", rule->host_port, rule->guest_port, &guest_addr));
+        LogRel(("NAT: set redirect %s host port %d => guest port %d @ %RTnaipv4\n",
+               rule->proto == IPPROTO_UDP ? "UDP" : "TCP", rule->host_port, rule->guest_port, guest_addr));
 
         if (rule->proto == IPPROTO_UDP)
@@ -1800,6 +1800,6 @@
             && rule->activated)
         {
-            LogRel(("NAT: remove redirect %s host port %d => guest port %d @ %R[naipv4]\n",
-                   rule->proto == IPPROTO_UDP ? "UDP" : "TCP", rule->host_port, rule->guest_port, &guest_addr));
+            LogRel(("NAT: remove redirect %s host port %d => guest port %d @ %RTnaipv4\n",
+                   rule->proto == IPPROTO_UDP ? "UDP" : "TCP", rule->host_port, rule->guest_port, guest_addr));
 
             LibAliasUninit(rule->so->so_la);
@@ -2095,6 +2095,6 @@
         if (!fBroadcastEtherAddReported)
         {
-            LogRel(("NAT: Attempt to add pair [%RTmac:%R[naipv4]] in ARP cache was ignored\n",
-                    mac, &dst));
+            LogRel(("NAT: Attempt to add pair [%RTmac:%RTnaipv4] in ARP cache was ignored\n",
+                    mac, dst));
             fBroadcastEtherAddReported = true;
         }
@@ -2145,5 +2145,5 @@
     LIST_FOREACH(ac, &pData->arp_cache, list)
     {
-        pHlp->pfnPrintf(pHlp, " %R[naipv4] %RTmac\n", &ac->ip, &ac->ether);
+        pHlp->pfnPrintf(pHlp, " %RTnaipv4 %RTmac\n", ac->ip, &ac->ether);
     }
 
@@ -2151,7 +2151,7 @@
     LIST_FOREACH(rule, &pData->port_forward_rule_head, list)
     {
-        pHlp->pfnPrintf(pHlp, " %s %d => %R[naipv4]:%d %c\n",
+        pHlp->pfnPrintf(pHlp, " %s %d => %RTnaipv4:%d %c\n",
                         rule->proto == IPPROTO_UDP ? "UDP" : "TCP",
-                        rule->host_port, &rule->guest_addr.s_addr, rule->guest_port,
+                        rule->host_port, rule->guest_addr.s_addr, rule->guest_port,
                         rule->activated ? ' ' : '*');
     }
Index: trunk/src/VBox/Devices/Network/slirp/udp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/udp.c	(revision 37745)
+++ trunk/src/VBox/Devices/Network/slirp/udp.c	(revision 37746)
@@ -97,5 +97,5 @@
     LogFlow(("udp_input: m = %lx, iphlen = %d\n", (long)m, iphlen));
     ip = mtod(m, struct ip *);
-    Log2(("%R[naipv4] iphlen = %d\n", &ip->ip_dst, iphlen));
+    Log2(("%RTnaipv4 iphlen = %d\n", ip->ip_dst, iphlen));
 
     udpstat.udps_ipackets++;
@@ -296,6 +296,6 @@
         m->m_data -= iphlen;
         *ip = save_ip;
-        Log2(("NAT: UDP tx errno = %d (%s) on sent to %R[naipv4]\n",
-              errno, strerror(errno), &ip->ip_dst));
+        Log2(("NAT: UDP tx errno = %d (%s) on sent to %RTnaipv4\n",
+              errno, strerror(errno), ip->ip_dst));
         icmp_error(pData, m, ICMP_UNREACH, ICMP_UNREACH_NET, 0, strerror(errno));
         so->so_m = NULL;
@@ -314,5 +314,5 @@
 
 bad_free_mbuf:
-    Log2(("NAT: UDP(id: %hd) datagram to %R[naipv4] with size(%d) claimed as bad\n",
+    Log2(("NAT: UDP(id: %hd) datagram to %RTnaipv4 with size(%d) claimed as bad\n",
         ip->ip_id, &ip->ip_dst, ip->ip_len));
 
@@ -518,5 +518,5 @@
     if (bind(so->s,(struct sockaddr *)&addr, addrlen) < 0)
     {
-        LogRel(("NAT: bind to %R[naipv4] has been failed\n", &addr.sin_addr));
+        LogRel(("NAT: bind to %RTnaipv4 has been failed\n", addr.sin_addr));
         udp_detach(pData, so);
         return NULL;